diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeavesCherryFlowering.java b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeavesCherryFlowering.java
index 48c0959a6..3e835ef06 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeavesCherryFlowering.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/generic/BlockModelGenericLeavesCherryFlowering.java
@@ -23,9 +23,9 @@ public class BlockModelGenericLeavesCherryFlowering<T extends BlockLogic> extend
     }
 
     @Override
-    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
-        super.renderStandalone(tessellator, metadata, lightmapCoord);
-        this.overlay.renderStandalone(this, tessellator, 0, 0, 0, metadata, lightmapCoord, BlockColorDispatcher.getInstance().getDispatch(this.block));
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, byte lightIndex) {
+        super.renderStandalone(tessellator, metadata, lightIndex);
+        this.overlay.renderStandalone(this, tessellator, 0, 0, 0, metadata, lightIndex, BlockColorDispatcher.getInstance().getDispatch(this.block));
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/camera/ICamera.java b/game/client/src/main/java/net/minecraft/client/render/camera/ICamera.java
index c0a2d0f45..583ffbb1d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/camera/ICamera.java
+++ b/game/client/src/main/java/net/minecraft/client/render/camera/ICamera.java
@@ -50,6 +50,18 @@ public interface ICamera {
         return getPosition(1f);
     }
 
+    default @NotNull Vector3d getPosition(float partialTick, @NotNull Vector3d out) {
+        out.x = this.getX(partialTick);
+        out.y = this.getY(partialTick);
+        out.z = this.getZ(partialTick);
+
+        return out;
+    }
+
+    default @NotNull Vector3d getPosition(@NotNull Vector3d out) {
+        return this.getPosition(1.0f, out);
+    }
+
     double getXRot(float partialTick);
 
     default double getXRot() {
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
index 6f760dfcb..865195a21 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRenderer.java
@@ -8,6 +8,7 @@ import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
@@ -16,7 +17,6 @@ import org.joml.primitives.AABBdc;
 
 import net.minecraft.client.render.EntityRendererDispatcher;
 import net.minecraft.client.render.ImageParser;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -116,9 +116,9 @@ public abstract class EntityRenderer<T extends Entity> {
         GLRenderer.modelM4f().rotateY(Math.toRadians(-this.renderDispatcher.viewLerpYaw));
         GLRenderer.modelM4f().translate(0.0F, 0.0F, -0.3F + (float) (int) f12 * 0.02F);
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        int lightmapCoord = entity.getLightmap(partialTick);
-        lightmapCoord = LightmapHelper.setBlocklightValue(lightmapCoord, 15);
-        GLRenderer.setLightmapCoord1i(lightmapCoord);
+        byte lightIndex = entity.getLightIndex(partialTick);
+        lightIndex = LightIndexHelper.setBlockLight(lightIndex, 15);
+        GLRenderer.setLightmapCoord1i(lightIndex);
         float f14 = 0.0F;
         int l = 0;
         tessellator.startDrawingQuads();
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
index b0c440bdb..fd943c5e1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
@@ -2,7 +2,6 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
-import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
index 11e8c3ac3..f548ab5cb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererItem.java
@@ -37,7 +37,7 @@ public class EntityRendererItem extends EntityRenderer<EntityItem> {
             renderCount = 4;
         }
         GLRenderer.modelM4f().translate((float) x, (float) (y + bobbingOffset), (float) z);
-        ItemModelDispatcher.getInstance().getDispatch(item).renderItemEntity(tessellator, itemstack, GameSettings.ITEMS_3D.value, renderCount, entity.age, yw, entity.getLightmap(partialTick), partialTick);
+        ItemModelDispatcher.getInstance().getDispatch(item).renderItemEntity(tessellator, itemstack, GameSettings.ITEMS_3D.value, renderCount, entity.age, yw, entity.getLightIndex(partialTick), partialTick);
         GLRenderer.popFrame();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
index 0c5c394ce..0ec356875 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
@@ -83,7 +83,7 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
             GLRenderer.modelM4f().scale(scale, scale, scale);
             GLRenderer.modelM4f().translate(0.0F, 0.3125F, 0.0F);
             GLRenderer.modelM4f().rotateY(org.joml.Math.PI_OVER_2_f);
-            GLRenderer.setLightmapCoord1i(minecart.getLightmap(partialTick));
+            GLRenderer.setLightmapCoord1i(minecart.getLightIndex(partialTick));
 
             GLRenderer.pushFrame();
             if (doAFlip) {
@@ -97,13 +97,13 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
                     } else {
                         block = Blocks.CHEST_PLANKS_OAK;
                     }
-                    BlockModelDispatcher.getInstance().getDispatch(block).renderStandalone(tessellator, minecart.getMeta(), minecart.getLightmap(partialTick));
+                    BlockModelDispatcher.getInstance().getDispatch(block).renderStandalone(tessellator, minecart.getMeta(), minecart.getLightIndex(partialTick));
                     break;
                 case EntityMinecart.FURNACE_CART:
                     if (minecart.getFuel() > 0) {
-                        BlockModelDispatcher.getInstance().getDispatch(Blocks.FURNACE_STONE_ACTIVE).renderStandalone(tessellator, 0, minecart.getLightmap(partialTick));
+                        BlockModelDispatcher.getInstance().getDispatch(Blocks.FURNACE_STONE_ACTIVE).renderStandalone(tessellator, 0, minecart.getLightIndex(partialTick));
                     } else {
-                        BlockModelDispatcher.getInstance().getDispatch(Blocks.FURNACE_STONE_IDLE).renderStandalone(tessellator, 0, minecart.getLightmap(partialTick));
+                        BlockModelDispatcher.getInstance().getDispatch(Blocks.FURNACE_STONE_IDLE).renderStandalone(tessellator, 0, minecart.getLightIndex(partialTick));
                     }
                     break;
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java
index 76e82e574..11e619e90 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
@@ -41,7 +40,7 @@ public class EntityRendererSprite<T extends Entity> extends EntityRenderer<T> {
         if (this.fullBright) {
             GLRenderer.globalSetLightEnabled(false);
             GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-            GLRenderer.setLightmapCoord1i(LightmapHelper.getLightmapCoord(15, 15));
+            GLRenderer.setLightmapCoord2i(15, 15);
         }
         GLRenderer.modelM4f().scale(0.5F * this.scale, 0.5F * this.scale, 0.5F * this.scale);
         this.itemIconIndex.parentAtlas.bind();
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
index dedc841a1..217fd95f1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererTNT.java
@@ -37,7 +37,7 @@ public class EntityRendererTNT extends EntityRenderer<EntityPrimedTNT> {
         float f3 = (1.0F - (((float) tnt.fuse - partialTick) + 1.0F) / 100F) * 0.8F;
         TextureRegistry.worldAtlas.bind();
         BlockModel<?> model = BlockModelDispatcher.getInstance().getDispatch(Blocks.TNT);
-        model.renderStandalone(tessellator, 0, tnt.getLightmap(partialTick));
+        model.renderStandalone(tessellator, 0, tnt.getLightIndex(partialTick));
         if ((tnt.fuse / 5) % 2 == 0) {
             GLRenderer.pushFrame();
             GLRenderer.setShader(Shaders.COLOR_WORLD);
@@ -45,7 +45,7 @@ public class EntityRendererTNT extends EntityRenderer<EntityPrimedTNT> {
             GLRenderer.enableState(State.BLEND);
             GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.DST_ALPHA);
             GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, f3);
-            model.renderStandalone(tessellator, 0, tnt.getLightmap(partialTick));
+            model.renderStandalone(tessellator, 0, tnt.getLightIndex(partialTick));
             GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             GLRenderer.disableState(State.BLEND);
             GLRenderer.globalSetLightEnabled(true);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java
index 1a1f57bca..c07cb3fcc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBiped.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
@@ -148,16 +147,14 @@ public abstract class MobRendererBiped<T extends Mob> extends MobRenderer<T> {
                     GLRenderer.modelM4f().scale(-1, 1, -1);
                     GLRenderer.modelM4f().scale(MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE);
                     ItemModelDispatcher.getInstance().getDispatch(itemstack)
-                        .render(tessellator, entity, itemstack, DisplayPos.THIRD_PERSON_LEFT_HAND, true, 1,
-                            LightmapHelper.getLightmapCoord(GLRenderer.getLightmapSky(), GLRenderer.getLightmapBlock()), partialTick, true);
+                        .render(tessellator, entity, itemstack, DisplayPos.THIRD_PERSON_LEFT_HAND, true, 1, GLRenderer.getLightIndex(), partialTick, true);
                 } else {
 
                     if (model != null) model.translateToBone("rightItem");
                     GLRenderer.modelM4f().scale(-1, 1, 1);
                     GLRenderer.modelM4f().scale(MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE);
                     ItemModelDispatcher.getInstance().getDispatch(itemstack)
-                        .render(tessellator, entity, itemstack, DisplayPos.THIRD_PERSON_RIGHT_HAND, true, 1,
-                            LightmapHelper.getLightmapCoord(GLRenderer.getLightmapSky(), GLRenderer.getLightmapBlock()), partialTick, false);
+                        .render(tessellator, entity, itemstack, DisplayPos.THIRD_PERSON_RIGHT_HAND, true, 1, GLRenderer.getLightIndex(), partialTick, false);
                 }
                 GLRenderer.popFrame();
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
index 7dabe22d0..82a73993a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererBipedArmored.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
@@ -109,7 +108,7 @@ public abstract class MobRendererBipedArmored<T extends Mob & IArmorWearing<Huma
                 GLRenderer.modelM4f().scale(0.6f, 0.6f, 0.6f);
                 GLRenderer.modelM4f().translate(0, 7 / 16f, 0);
                 ItemModelDispatcher.getInstance().getDispatch(stack).render(GLRenderer.getTessellator(), null, stack, DisplayPos.HEAD, true, 1,
-                    LightmapHelper.getLightmapCoord(GLRenderer.getLightmapSky(), GLRenderer.getLightmapBlock()), partialTick, true);
+                    GLRenderer.getLightIndex(), partialTick, true);
                 GLRenderer.disableState(State.CULL_FACE);
                 GLRenderer.popFrame();
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSpider.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSpider.java
index 0a7269b45..64310d8da 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSpider.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererSpider.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.render.entity;
 
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
@@ -21,7 +20,7 @@ public class MobRendererSpider extends MobRenderer<MobSpider> {
     protected @Nullable StaticEntityModel getAndSetupModelForLayer(@NotNull final MobSpider entity, final float brightness, final float partialTick, final int layer) {
         if (layer == 1) {
             bindTexture("/assets/minecraft/textures/entity/spider/eyes/" + entity.getTextureReference() + ".png");
-            GLRenderer.setLightmapCoord1i(LightmapHelper.getOverbrightLightmapCoord(15));
+            GLRenderer.setLightmapCoord2i(15, 15);
             GLRenderer.enableState(State.BLEND);
             GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
             GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, (1.0F - entity.getBrightness(partialTick)) * 0.5F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
index 8c44b4b62..508c84db4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
@@ -126,7 +126,7 @@ public class MobRendererWolf extends MobRenderer<MobWolf> {
             getModel("main").translateToBone("mouthItem");
             GLRenderer.modelM4f().scale(MobRenderer.ENTITY_RENDER_SCALE, -MobRenderer.ENTITY_RENDER_SCALE, MobRenderer.ENTITY_RENDER_SCALE);
             GLRenderer.enableState(State.BLEND);
-            ItemModelDispatcher.getInstance().getDispatch(itemstack).render(GLRenderer.getTessellator(), entity, itemstack, DisplayPos.GROUND, GameSettings.ITEMS_3D.value, 1, entity.getLightmap(partialTick), partialTick, true);
+            ItemModelDispatcher.getInstance().getDispatch(itemstack).render(GLRenderer.getTessellator(), entity, itemstack, DisplayPos.GROUND, GameSettings.ITEMS_3D.value, 1, entity.getLightIndex(partialTick), partialTick, true);
             GLRenderer.disableState(State.BLEND);
             GLRenderer.popFrame();
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
index 52e2f3e1c..71e019730 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/FontRendererDefault.java
@@ -14,6 +14,7 @@ import net.minecraft.client.render.tessellator.TessellatorFont;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
+import net.minecraft.core.util.helper.LightIndexHelper;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -800,7 +801,7 @@ public class FontRendererDefault extends FontRenderer {
             GL41.glVertexAttribPointer(0, 3, GL41.GL_FLOAT, false, VERT_SIZE, 0);
             GL41.glVertexAttribPointer(1, 4, GL41.GL_UNSIGNED_BYTE, true, VERT_SIZE, Float.BYTES * 3);
             GL41.glVertexAttrib2f(2, 0f, 0f);
-            GL41.glVertexAttrib2f(3, 15.5f/16f, 15.5f/16f);
+            GL41.glVertexAttrib1f(3, LightIndexHelper.lightIndex2i(15, 15));
             GL41.glVertexAttrib3f(4, 0, -1f, 0);
 
             GL41.glEnableVertexAttribArray(0);
@@ -854,7 +855,7 @@ public class FontRendererDefault extends FontRenderer {
             if (this.vertexCount == 0) return;
 
             GL41.glBindVertexArray(this.vao);
-            GL41.glVertexAttrib2f(3, GLRenderer.getLightmapBlock(), GLRenderer.getLightmapSky());
+            GL41.glVertexAttrib1f(3, GLRenderer.getLightIndex());
 
             GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
             GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STREAM_DRAW);
@@ -872,7 +873,7 @@ public class FontRendererDefault extends FontRenderer {
             this.drawing = false;
 
             GL41.glBindVertexArray(this.vao);
-            GL41.glVertexAttrib2f(3, GLRenderer.getLightmapBlock(), GLRenderer.getLightmapSky());
+            GL41.glVertexAttrib1f(3, GLRenderer.getLightIndex());
 
             GL41.glBindBuffer(GL41.GL_ARRAY_BUFFER, this.vbo);
             GL41.glBufferData(GL41.GL_ARRAY_BUFFER, this.data.flip(), GL41.GL_STATIC_DRAW);
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
index 7f99fffff..2e6d097dc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
@@ -2,7 +2,6 @@ package net.minecraft.client.render.item.model;
 
 import net.minecraft.client.render.EntityRendererDispatcher;
 import net.minecraft.client.render.ItemRenderer;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.renderer.BlendFactor;
@@ -28,37 +27,37 @@ public abstract class ItemModel {
         this.item = item;
     }
 
-    public abstract void render(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, @NotNull String displayPosId, boolean items3d, int clusterSize, int lightmapCoord, float partialTick, boolean mirrorX); // TODO figure out if theres a way to not explicitly need to mirrorX in the model itself
+    public abstract void render(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, @NotNull String displayPosId, boolean items3d, int clusterSize, byte lightIndex, float partialTick, boolean mirrorX); // TODO figure out if theres a way to not explicitly need to mirrorX in the model itself
     public abstract void renderItemOverlayIntoGUI(@NotNull TessellatorGeneral tessellator, @NotNull FontRenderer fontRenderer, @NotNull TextureManager textureManager, @NotNull ItemStack itemstack, int x, int y, @Nullable String override, float alpha);
 
-    public void renderGui(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, int x, int y, int lightmapCoord, float partialTick) {
+    public void renderGui(@NotNull TessellatorGeneral tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, int x, int y, byte lightIndex, float partialTick) {
         GLRenderer.pushFrame();
-        GLRenderer.setShader(Shaders.TERRAIN);
+        GLRenderer.setShader(Shaders.ITEM);
         GLRenderer.globalSetLightEnabled(false);
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         GLRenderer.enableState(State.CULL_FACE);
         GLRenderer.modelM4f().translate(x + 8, y + 8, 0);
         GLRenderer.modelM4f().scale(16, -16, 1);
-        render(tessellator, holder, itemStack, DisplayPos.GUI, false, 1, LightmapHelper.getLightmapCoord(15, 15), partialTick, false);
+        render(tessellator, holder, itemStack, DisplayPos.GUI, false, 1, lightIndex, partialTick, false);
         GLRenderer.globalSetLightEnabled(true);
         GLRenderer.popFrame();
     }
 
-    public void renderItemEntity(@NotNull TessellatorGeneral tessellator, @NotNull ItemStack itemStack, boolean items3d, int clusterSize, int ticks, float yaw, int lightmap, float partialTick) {
+    public void renderItemEntity(@NotNull TessellatorGeneral tessellator, @NotNull ItemStack itemStack, boolean items3d, int clusterSize, int ticks, float yaw, byte lightIndex, float partialTick) {
         GLRenderer.enableState(State.BLEND);
         if (items3d) {
             GLRenderer.modelM4f().rotateY(Math.toRadians(yaw));
         } else {
             GLRenderer.modelM4f().rotateY(Math.toRadians(180F - EntityRendererDispatcher.instance.viewLerpYaw));
         }
-        render(tessellator, null, itemStack, DisplayPos.GROUND, items3d, clusterSize, lightmap, partialTick, false);
+        render(tessellator, null, itemStack, DisplayPos.GROUND, items3d, clusterSize, lightIndex, partialTick, false);
         GLRenderer.disableState(State.BLEND);
     }
 
-    public void renderFirstPerson(@NotNull TessellatorGeneral tessellator, @NotNull ItemRenderer itemRenderer, @NotNull Player player, @NotNull ItemStack itemStack, int lightmapCoord, float partialTick) {
+    public void renderFirstPerson(@NotNull TessellatorGeneral tessellator, @NotNull ItemRenderer itemRenderer, @NotNull Player player, @NotNull ItemStack itemStack, byte lightIndex, float partialTick) {
         GLRenderer.pushFrame();
-        GLRenderer.setShader(Shaders.TERRAIN);
+        GLRenderer.setShader(Shaders.ITEM);
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         GLRenderer.enableState(State.CULL_FACE);
@@ -83,7 +82,7 @@ public abstract class ItemModel {
             GLRenderer.modelM4f().rotateY(Math.toRadians(-45));
 
             GLRenderer.setFrontFace(FrontFace.CW);
-            render(tessellator,player, itemStack, DisplayPos.FIRST_PERSON_LEFT_HAND, true, 1, lightmapCoord, partialTick, true);
+            render(tessellator,player, itemStack, DisplayPos.FIRST_PERSON_LEFT_HAND, true, 1, lightIndex, partialTick, true);
             GLRenderer.setFrontFace(FrontFace.CCW);
         } else {
             final float xOff = 9/16f;
@@ -100,7 +99,7 @@ public abstract class ItemModel {
             GLRenderer.modelM4f().rotateX(Math.toRadians(-animationProgress) * 80F);
             GLRenderer.modelM4f().rotateY(Math.toRadians(-45));
 
-            render(tessellator,player, itemStack, DisplayPos.FIRST_PERSON_RIGHT_HAND, true, 1, lightmapCoord, partialTick, false);
+            render(tessellator,player, itemStack, DisplayPos.FIRST_PERSON_RIGHT_HAND, true, 1, lightIndex, partialTick, false);
         }
         GLRenderer.popFrame();
     }
